Device (pci8086,3e30)
{
	Name (_ADR, 0x00000000)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "8th Gen Core 8-core Desktop Processor Host Bridge/DRAM Registers [Coffee Lake S]" },
			"device_type", Buffer () { "Host bridge" },
			"AAPL,slot-name", Buffer () { "Internal@0,0,0" },
		})
	}
}
Device (PEG0)
{
	Name (_ADR, 0x00010000)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "Xeon E3-1200 v5/E3-1500 v5/6th Gen Core Processor PCIe Controller (x16)" },
			"device_type", Buffer () { "PCI bridge" },
			"AAPL,slot-name", Buffer () { "Internal@0,1,0" },
		})
	}
}
Device (pci8086,a379)
{
	Name (_ADR, 0x00120000)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "Cannon Lake PCH Thermal Controller" },
			"device_type", Buffer () { "Signal processing controller" },
			"AAPL,slot-name", Buffer () { "Internal@0,18,0" },
		})
	}
}
Device (XHC)
{
	Name (_ADR, 0x00140000)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "Cannon Lake PCH USB 3.1 xHCI Host Controller" },
			"device_type", Buffer () { "USB controller" },
			"AAPL,slot-name", Buffer () { "Internal@0,20,0" },
		})
	}
}
Device (pci8086,a36f)
{
	Name (_ADR, 0x00140002)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "Cannon Lake PCH Shared SRAM" },
			"device_type", Buffer () { "RAM memory" },
			"AAPL,slot-name", Buffer () { "Internal@0,20,2" },
		})
	}
}
Device (IMEI)
{
	Name (_ADR, 0x00160000)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "Cannon Lake PCH HECI Controller" },
			"device_type", Buffer () { "Communication controller" },
			"AAPL,slot-name", Buffer () { "Internal@0,22,0" },
		})
	}
}
Device (SAT0)
{
	Name (_ADR, 0x00170000)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "Cannon Lake PCH SATA AHCI Controller" },
			"device_type", Buffer () { "SATA controller" },
			"AAPL,slot-name", Buffer () { "Internal@0,23,0" },
		})
	}
}
Device (RP17)
{
	Name (_ADR, 0x001b0000)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "Cannon Lake PCH PCI Express Root Port #17" },
			"device_type", Buffer () { "PCI bridge" },
			"AAPL,slot-name", Buffer () { "Internal@0,27,0" },
		})
	}
}
Device (PEG0.GFX0)
{
	Name (_ADR, 0x00000000)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "Baffin [Radeon RX 550 640SP / RX 560/560X]" },
			"hda-gfx", Buffer () { "onboard-1" },
			"AAPL,slot-name", Buffer () { "Internal@0,1,0/0,0" },
			"device_type", Buffer () { "VGA compatible controller" },
		})
	}
}
Device (RP21)
{
	Name (_ADR, 0x001b0004)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "Cannon Lake PCH PCI Express Root Port #21" },
			"device_type", Buffer () { "PCI bridge" },
			"AAPL,slot-name", Buffer () { "Internal@0,27,4" },
		})
	}
}
Device (PEG0.HDAU)
{
	Name (_ADR, 0x00000001)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "Baffin HDMI/DP Audio [Radeon RX 550 640SP / RX 560/560X]" },
			"device_type", Buffer () { "Audio device" },
			"AAPL,slot-name", Buffer () { "Internal@0,1,0/0,1" },
		})
	}
}
Device (RP01)
{
	Name (_ADR, 0x001c0000)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "Cannon Lake PCH PCI Express Root Port #1" },
			"device_type", Buffer () { "PCI bridge" },
			"AAPL,slot-name", Buffer () { "Internal@0,28,0" },
		})
	}
}
Device (RP09)
{
	Name (_ADR, 0x001d0000)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "Cannon Lake PCH PCI Express Root Port #9" },
			"device_type", Buffer () { "PCI bridge" },
			"AAPL,slot-name", Buffer () { "Internal@0,29,0" },
		})
	}
}
Device (LPCB)
{
	Name (_ADR, 0x001f0000)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "Z390 Chipset LPC/eSPI Controller" },
			"device_type", Buffer () { "ISA bridge" },
			"AAPL,slot-name", Buffer () { "Internal@0,31,0" },
		})
	}
}
Device (HDEF)
{
	Name (_ADR, 0x001f0003)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "Cannon Lake PCH cAVS" },
			"layout-id", Buffer () { 0x00, 0x00, 0x00, 0x00 },
			"hda-gfx", Buffer () { "onboard-1" },
			"AAPL,slot-name", Buffer () { "Internal@0,31,3" },
			"device_type", Buffer () { "Audio device" },
		})
	}
}
Device (SBUS)
{
	Name (_ADR, 0x001f0004)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "Cannon Lake PCH SMBus Controller" },
			"device_type", Buffer () { "SMBus" },
			"AAPL,slot-name", Buffer () { "Internal@0,31,4" },
		})
	}
}
Device (pci8086,a324)
{
	Name (_ADR, 0x001f0005)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "Cannon Lake PCH SPI Controller" },
			"device_type", Buffer () { "Serial bus controller" },
			"AAPL,slot-name", Buffer () { "Internal@0,31,5" },
		})
	}
}
Device (GLAN)
{
	Name (_ADR, 0x001f0006)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "Ethernet Connection (7) I219-V" },
			"device_type", Buffer () { "Ethernet controller" },
			"AAPL,slot-name", Buffer () { "Internal@0,31,6" },
		})
	}
}
Device (RP21.PXSX)
{
	Name (_ADR, 0x00000000)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "BCM43602 802.11ac Wireless LAN SoC" },
			"device_type", Buffer () { "Network controller" },
			"AAPL,slot-name", Buffer () { "Internal@0,27,4/0,0" },
		})
	}
}
Device (RP09.PXSX)
{
	Name (_ADR, 0x00000000)
	Method (_DSM, 4, NotSerialized)
	{
		If (LEqual (Arg2, Zero)) { Return (Buffer() { 0x03 } ) }
		Return (Package ()
		{
			"model", Buffer () { "NVMe SSD Controller SM981/PM981/PM983" },
			"device_type", Buffer () { "Non-Volatile memory controller" },
			"AAPL,slot-name", Buffer () { "Internal@0,29,0/0,0" },
		})
	}
}
